diff --git a/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index 234f3bbd0..99db8f0f1 100644
--- a/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -23,7 +23,7 @@ public class MathHelper
         return (float) java.lang.Math.sqrt(f);
     }
 
-    public static float sqrt_double(double d)
+    public static float sqrt(double d)
     {
         return (float) java.lang.Math.sqrt(d);
     }
@@ -34,7 +34,7 @@ public class MathHelper
         return f >= (float)i ? i : i - 1;
     }
 
-    public static int floor_double(double d)
+    public static int floor(double d)
     {
         int truncated = (int)d;
         return d >= (double)truncated ? truncated : truncated - 1;
@@ -85,8 +85,10 @@ public class MathHelper
         return Math.max(value, min);
     }
 
-    public static float lerp(float a, float b, float amount)
-    {
+    public static float lerp(float a, float b, float amount) {
+        return a + ((b - a) * amount);
+    }
+    public static double lerp(double a, double b, double amount) {
         return a + ((b - a) * amount);
     }
 	
@@ -117,31 +119,51 @@ public class MathHelper
      * @return rotation bounded to the range [-180, 180) degrees
      */
     public static double normalizeRotation(double rotation){
-        return rotation + 360D * (int) -((rotation+180)/360);
+        double rotNorm = unsignedMod(rotation, 360);
+        if (rotNorm < 180) return rotNorm;
+        return rotNorm - 360;
     }
     /**
      * @param rotation value in degrees
      * @return rotation bounded to the range [-180, 180) degrees
      */
     public static float normalizeRotation(float rotation){
-        return rotation + 360F * (int) -((rotation+180)/360);
+        float rotNorm = (float) unsignedMod(rotation, 360);
+        if (rotNorm < 180) return rotNorm;
+        return rotNorm - 360;
+    }
+
+    public static double deltaAngle(double a, double b){
+        return unsignedMod((a - b + 180), 360) -180;
+    }
+    public static double unsignedMod(double value, double n){
+        return value - Math.floor(value/n) * n;
     }
+
     private static final float[] SIN_TABLE;
 
     public static final float PI = (float)Math.PI;
 
+    public static float toRadians(float angleDegrees){
+        return angleDegrees * DEG_TO_RAD;
+    }
+
+    public static float toDegrees(float angleRadians){
+        return angleRadians * RAD_TO_DEG;
+    }
+
+    public static final float DEG_TO_RAD = (float)Math.toRadians(1);
+    public static final float RAD_TO_DEG = (float)Math.toDegrees(1);
+
     public static int maxAbs(int a, int b)
     {
         return Math.abs(a) > Math.abs(b) ? a : b;
     }
 
-    static 
-    {
+    static {
         SIN_TABLE = new float[0x10000];
-        for(int i = 0; i < 0x10000; i++)
-        {
-            SIN_TABLE[i] = (float) java.lang.Math.sin(((double)i * 3.1415926535897931D * 2D) / 65536D);
+        for(int i = 0; i < 0x10000; i++) {
+            SIN_TABLE[i] = (float) Math.sin(((double)i * Math.PI * 2D) / 65536D);
         }
-
     }
 }
diff --git a/src/main/java/net/minecraft/core/util/phys/AABB.java b/src/main/java/net/minecraft/core/util/phys/AABB.java
index 4a36cd367..d1fcf3616 100644
--- a/src/main/java/net/minecraft/core/util/phys/AABB.java
+++ b/src/main/java/net/minecraft/core/util/phys/AABB.java
@@ -1,101 +1,104 @@
 package net.minecraft.core.util.phys;
 
-import net.minecraft.core.HitResult;
 import net.minecraft.core.util.helper.Side;
 
 import java.util.ArrayList;
 import java.util.List;
 
-// Referenced classes of package net.minecraft.src:
-//            Vec3D, MovingObjectPosition
-
 public class AABB
 {
+    private static final List<AABB> pool = new ArrayList<>();
+    private static int poolPointer = 0;
+    public double minX;
+    public double minY;
+    public double minZ;
+    public double maxX;
+    public double maxY;
+    public double maxZ;
 
-    public static AABB getBoundingBox(double d, double d1, double d2, double d3,
-                                      double d4, double d5)
+    public static AABB getPermanentBB(double d, double d1, double d2, double d3, double d4, double d5)
     {
         return new AABB(d, d1, d2, d3, d4, d5);
     }
 
     public static void deinitializePool()
     {
-        boundingBoxes.clear();
-        numBoundingBoxesInUse = 0;
+        pool.clear();
+        poolPointer = 0;
     }
 
     public static void initializePool()
     {
-        numBoundingBoxesInUse = 0;
+        poolPointer = 0;
     }
 
-    public static AABB getBoundingBoxFromPool(double minX, double minY, double minZ, double maxX,
-                                              double maxY, double maxZ)
+    public static AABB getTemporaryBB(double minX, double minY, double minZ, double maxX,
+                                      double maxY, double maxZ)
     {
-        if(numBoundingBoxesInUse >= boundingBoxes.size())
+        if(poolPointer >= pool.size())
         {
-            boundingBoxes.add(getBoundingBox(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D));
+            pool.add(getPermanentBB(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D));
         }
-        return ((AABB)boundingBoxes.get(numBoundingBoxesInUse++)).setBounds(minX, minY, minZ, maxX, maxY, maxZ);
+        return pool.get(poolPointer++).set(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
-    public AABB(double d, double d1, double d2, double d3, double d4, double d5)
+    private AABB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
     {
-        minX = d;
-        minY = d1;
-        minZ = d2;
-        maxX = d3;
-        maxY = d4;
-        maxZ = d5;
+        this.minX = minX;
+        this.minY = minY;
+        this.minZ = minZ;
+        this.maxX = maxX;
+        this.maxY = maxY;
+        this.maxZ = maxZ;
     }
 
-    public AABB setBounds(double d, double d1, double d2, double d3, double d4, double d5)
+    public AABB set(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
     {
-        minX = d;
-        minY = d1;
-        minZ = d2;
-        maxX = d3;
-        maxY = d4;
-        maxZ = d5;
+        this.minX = minX;
+        this.minY = minY;
+        this.minZ = minZ;
+        this.maxX = maxX;
+        this.maxY = maxY;
+        this.maxZ = maxZ;
         return this;
     }
 
-    public AABB addCoord(double d, double d1, double d2)
+    public AABB expand(double stretchX, double stretchY, double stretchZ)
     {
-        double d3 = minX;
-        double d4 = minY;
-        double d5 = minZ;
-        double d6 = maxX;
-        double d7 = maxY;
-        double d8 = maxZ;
-        if(d < 0.0D)
+        double minX = this.minX;
+        double minY = this.minY;
+        double minZ = this.minZ;
+        double maxX = this.maxX;
+        double maxY = this.maxY;
+        double maxZ = this.maxZ;
+        if(stretchX < 0.0D)
         {
-            d3 += d;
+            minX += stretchX;
         }
-        if(d > 0.0D)
+        if(stretchX > 0.0D)
         {
-            d6 += d;
+            maxX += stretchX;
         }
-        if(d1 < 0.0D)
+        if(stretchY < 0.0D)
         {
-            d4 += d1;
+            minY += stretchY;
         }
-        if(d1 > 0.0D)
+        if(stretchY > 0.0D)
         {
-            d7 += d1;
+            maxY += stretchY;
         }
-        if(d2 < 0.0D)
+        if(stretchZ < 0.0D)
         {
-            d5 += d2;
+            minZ += stretchZ;
         }
-        if(d2 > 0.0D)
+        if(stretchZ > 0.0D)
         {
-            d8 += d2;
+            maxZ += stretchZ;
         }
-        return getBoundingBoxFromPool(d3, d4, d5, d6, d7, d8);
+        return getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
-    public AABB expand(double d, double d1, double d2)
+    public AABB grow(double d, double d1, double d2)
     {
         double d3 = minX - d;
         double d4 = minY - d1;
@@ -103,35 +106,35 @@ public class AABB
         double d6 = maxX + d;
         double d7 = maxY + d1;
         double d8 = maxZ + d2;
-        return getBoundingBoxFromPool(d3, d4, d5, d6, d7, d8);
+        return getTemporaryBB(d3, d4, d5, d6, d7, d8);
     }
 
-    public AABB getOffsetBoundingBox(double d, double d1, double d2)
+    public AABB cloneMove(double offX, double offY, double offZ)
     {
-        return getBoundingBoxFromPool(minX + d, minY + d1, minZ + d2, maxX + d, maxY + d1, maxZ + d2);
+        return getTemporaryBB(minX + offX, minY + offY, minZ + offZ, maxX + offX, maxY + offY, maxZ + offZ);
     }
 
-    public double calculateXOffset(AABB axisalignedbb, double d)
+    public double clipXCollide(AABB aabb, double d)
     {
-        if(axisalignedbb.maxY <= minY || axisalignedbb.minY >= maxY)
+        if(aabb.maxY <= minY || aabb.minY >= maxY)
         {
             return d;
         }
-        if(axisalignedbb.maxZ <= minZ || axisalignedbb.minZ >= maxZ)
+        if(aabb.maxZ <= minZ || aabb.minZ >= maxZ)
         {
             return d;
         }
-        if(d > 0.0D && axisalignedbb.maxX <= minX)
+        if(d > 0.0D && aabb.maxX <= minX)
         {
-            double d1 = minX - axisalignedbb.maxX;
+            double d1 = minX - aabb.maxX;
             if(d1 < d)
             {
                 d = d1;
             }
         }
-        if(d < 0.0D && axisalignedbb.minX >= maxX)
+        if(d < 0.0D && aabb.minX >= maxX)
         {
-            double d2 = maxX - axisalignedbb.minX;
+            double d2 = maxX - aabb.minX;
             if(d2 > d)
             {
                 d = d2;
@@ -140,27 +143,27 @@ public class AABB
         return d;
     }
 
-    public double calculateYOffset(AABB axisalignedbb, double d)
+    public double clipYCollide(AABB aabb, double d)
     {
-        if(axisalignedbb.maxX <= minX || axisalignedbb.minX >= maxX)
+        if(aabb.maxX <= minX || aabb.minX >= maxX)
         {
             return d;
         }
-        if(axisalignedbb.maxZ <= minZ || axisalignedbb.minZ >= maxZ)
+        if(aabb.maxZ <= minZ || aabb.minZ >= maxZ)
         {
             return d;
         }
-        if(d > 0.0D && axisalignedbb.maxY <= minY)
+        if(d > 0.0D && aabb.maxY <= minY)
         {
-            double d1 = minY - axisalignedbb.maxY;
+            double d1 = minY - aabb.maxY;
             if(d1 < d)
             {
                 d = d1;
             }
         }
-        if(d < 0.0D && axisalignedbb.minY >= maxY)
+        if(d < 0.0D && aabb.minY >= maxY)
         {
-            double d2 = maxY - axisalignedbb.minY;
+            double d2 = maxY - aabb.minY;
             if(d2 > d)
             {
                 d = d2;
@@ -169,27 +172,27 @@ public class AABB
         return d;
     }
 
-    public double calculateZOffset(AABB axisalignedbb, double d)
+    public double clipZCollide(AABB aabb, double d)
     {
-        if(axisalignedbb.maxX <= minX || axisalignedbb.minX >= maxX)
+        if(aabb.maxX <= minX || aabb.minX >= maxX)
         {
             return d;
         }
-        if(axisalignedbb.maxY <= minY || axisalignedbb.minY >= maxY)
+        if(aabb.maxY <= minY || aabb.minY >= maxY)
         {
             return d;
         }
-        if(d > 0.0D && axisalignedbb.maxZ <= minZ)
+        if(d > 0.0D && aabb.maxZ <= minZ)
         {
-            double d1 = minZ - axisalignedbb.maxZ;
+            double d1 = minZ - aabb.maxZ;
             if(d1 < d)
             {
                 d = d1;
             }
         }
-        if(d < 0.0D && axisalignedbb.minZ >= maxZ)
+        if(d < 0.0D && aabb.minZ >= maxZ)
         {
-            double d2 = maxZ - axisalignedbb.minZ;
+            double d2 = maxZ - aabb.minZ;
             if(d2 > d)
             {
                 d = d2;
@@ -198,50 +201,75 @@ public class AABB
         return d;
     }
 
-    public boolean intersectsWith(AABB axisalignedbb)
-    {
-        if(axisalignedbb.maxX <= minX || axisalignedbb.minX >= maxX)
-        {
-            return false;
-        }
-        if(axisalignedbb.maxY <= minY || axisalignedbb.minY >= maxY)
-        {
-            return false;
-        }
-        return axisalignedbb.maxZ > minZ && axisalignedbb.minZ < maxZ;
+    public boolean intersects(AABB aabb) {
+        return aabb.maxX > this.minX && aabb.minX < this.maxX && aabb.maxY > this.minY && aabb.minY < this.maxY && aabb.maxZ > this.minZ && aabb.minZ < this.maxZ;
+    }
+    public boolean intersects(double minX, double minY, double minZ, double maxX, double maxY, double maxZ) {
+        return maxX > this.minX && minX < this.maxX && maxY > this.minY && minY < this.maxY && maxZ > this.minZ && minZ < this.maxZ;
+    }
+
+    public boolean intersectsInner(final AABB aabb) {
+        return aabb.maxX >= this.minX && aabb.minX <= this.maxX && aabb.maxY >= this.minY && aabb.minY <= this.maxY && aabb.maxZ >= this.minZ && aabb.minZ <= this.maxZ;
     }
 
-    public AABB offset(double d, double d1, double d2)
+    public AABB move(double offX, double offY, double offZ)
     {
-        minX += d;
-        minY += d1;
-        minZ += d2;
-        maxX += d;
-        maxY += d1;
-        maxZ += d2;
+        minX += offX;
+        minY += offY;
+        minZ += offZ;
+        maxX += offX;
+        maxY += offY;
+        maxZ += offZ;
         return this;
     }
 
-    public boolean isVecInside(Vec3d vec3d)
+    public boolean contains(Vec3 vec3)
     {
-        if(vec3d.xCoord <= minX || vec3d.xCoord >= maxX)
+        if(vec3.x <= minX || vec3.x >= maxX)
         {
             return false;
         }
-        if(vec3d.yCoord <= minY || vec3d.yCoord >= maxY)
+        if(vec3.y <= minY || vec3.y >= maxY)
         {
             return false;
         }
-        return vec3d.zCoord > minZ && vec3d.zCoord < maxZ;
+        return vec3.z > minZ && vec3.z < maxZ;
     }
 
-    public double getAverageEdgeLength()
+    public double getSize()
     {
         double d = maxX - minX;
         double d1 = maxY - minY;
         double d2 = maxZ - minZ;
         return (d + d1 + d2) / 3D;
     }
+    public AABB shrink(final double n, final double n2, final double n3) {
+        double minX = this.minX;
+        double minY = this.minY;
+        double minZ = this.minZ;
+        double maxX = this.maxX;
+        double maxY = this.maxY;
+        double maxZ = this.maxZ;
+        if (n < 0.0) {
+            minX -= n;
+        }
+        if (n > 0.0) {
+            maxX -= n;
+        }
+        if (n2 < 0.0) {
+            minY -= n2;
+        }
+        if (n2 > 0.0) {
+            maxY -= n2;
+        }
+        if (n3 < 0.0) {
+            minZ -= n3;
+        }
+        if (n3 > 0.0) {
+            maxZ -= n3;
+        }
+        return getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
+    }
 
     public AABB getInsetBoundingBox(double d, double d1, double d2)
     {
@@ -251,106 +279,96 @@ public class AABB
         double d6 = maxX - d;
         double d7 = maxY - d1;
         double d8 = maxZ - d2;
-        return getBoundingBoxFromPool(d3, d4, d5, d6, d7, d8);
+        return getTemporaryBB(d3, d4, d5, d6, d7, d8);
     }
 
     public AABB copy()
     {
-        return getBoundingBoxFromPool(minX, minY, minZ, maxX, maxY, maxZ);
+        return getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
-	public HitResult func_1169_a(Vec3d start, Vec3d end) {
-		Vec3d vec3d2 = start.getIntermediateWithXValue(end, minX);
-		Vec3d vec3d3 = start.getIntermediateWithXValue(end, maxX);
-		Vec3d vec3d4 = start.getIntermediateWithYValue(end, minY);
-		Vec3d vec3d5 = start.getIntermediateWithYValue(end, maxY);
-		Vec3d vec3d6 = start.getIntermediateWithZValue(end, minZ);
-		Vec3d vec3d7 = start.getIntermediateWithZValue(end, maxZ);
+	public HitResult clip(Vec3 start, Vec3 end) {
+		Vec3 vec32 = start.clipX(end, minX);
+		Vec3 vec3d3 = start.clipX(end, maxX);
+		Vec3 vec34 = start.clipY(end, minY);
+		Vec3 vec35 = start.clipY(end, maxY);
+		Vec3 vec36 = start.clipZ(end, minZ);
+		Vec3 vec37 = start.clipZ(end, maxZ);
 		
-		if(!isVecInYZ(vec3d2)) vec3d2 = null;
-		if(!isVecInYZ(vec3d3)) vec3d3 = null;
-		if(!isVecInXZ(vec3d4)) vec3d4 = null;
-		if(!isVecInXZ(vec3d5)) vec3d5 = null;
-		if(!isVecInXY(vec3d6)) vec3d6 = null;
-		if(!isVecInXY(vec3d7)) vec3d7 = null;
+		if(!containsX(vec32)) vec32 = null;
+		if(!containsX(vec3d3)) vec3d3 = null;
+		if(!containsY(vec34)) vec34 = null;
+		if(!containsY(vec35)) vec35 = null;
+		if(!containsZ(vec36)) vec36 = null;
+		if(!containsZ(vec37)) vec37 = null;
 		
-		Vec3d vec3d8 = null;
-		if(vec3d2 != null && (vec3d8 == null || start.squareDistanceTo(vec3d2) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d2;
-		if(vec3d3 != null && (vec3d8 == null || start.squareDistanceTo(vec3d3) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d3;
-		if(vec3d4 != null && (vec3d8 == null || start.squareDistanceTo(vec3d4) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d4;
-		if(vec3d5 != null && (vec3d8 == null || start.squareDistanceTo(vec3d5) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d5;
-		if(vec3d6 != null && (vec3d8 == null || start.squareDistanceTo(vec3d6) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d6;
-		if(vec3d7 != null && (vec3d8 == null || start.squareDistanceTo(vec3d7) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d7;
+		Vec3 vec38 = null;
+		if(vec32 != null && (vec38 == null || start.distanceToSquared(vec32) < start.distanceToSquared(vec38))) vec38 = vec32;
+		if(vec3d3 != null && (vec38 == null || start.distanceToSquared(vec3d3) < start.distanceToSquared(vec38))) vec38 = vec3d3;
+		if(vec34 != null && (vec38 == null || start.distanceToSquared(vec34) < start.distanceToSquared(vec38))) vec38 = vec34;
+		if(vec35 != null && (vec38 == null || start.distanceToSquared(vec35) < start.distanceToSquared(vec38))) vec38 = vec35;
+		if(vec36 != null && (vec38 == null || start.distanceToSquared(vec36) < start.distanceToSquared(vec38))) vec38 = vec36;
+		if(vec37 != null && (vec38 == null || start.distanceToSquared(vec37) < start.distanceToSquared(vec38))) vec38 = vec37;
 		
-		if(vec3d8 == null) return null;
+		if(vec38 == null) return null;
 		
 		Side side = Side.NONE;
-		if(vec3d8 == vec3d2) side = Side.WEST;
-		if(vec3d8 == vec3d3) side = Side.EAST;
-		if(vec3d8 == vec3d4) side = Side.BOTTOM;
-		if(vec3d8 == vec3d5) side = Side.TOP;
-		if(vec3d8 == vec3d6) side = Side.NORTH;
-		if(vec3d8 == vec3d7) side = Side.SOUTH;
+		if(vec38 == vec32) side = Side.WEST;
+		if(vec38 == vec3d3) side = Side.EAST;
+		if(vec38 == vec34) side = Side.BOTTOM;
+		if(vec38 == vec35) side = Side.TOP;
+		if(vec38 == vec36) side = Side.NORTH;
+		if(vec38 == vec37) side = Side.SOUTH;
 		
-		return new HitResult(0, 0, 0, side, vec3d8);
+		return new HitResult(0, 0, 0, side, vec38);
 	}
 
-    private boolean isVecInYZ(Vec3d vec3d)
+    private boolean containsX(Vec3 vec3)
     {
-        if(vec3d == null)
+        if(vec3 == null)
         {
             return false;
         } else
         {
-            return vec3d.yCoord >= minY && vec3d.yCoord <= maxY && vec3d.zCoord >= minZ && vec3d.zCoord <= maxZ;
+            return vec3.y >= minY && vec3.y <= maxY && vec3.z >= minZ && vec3.z <= maxZ;
         }
     }
 
-    private boolean isVecInXZ(Vec3d vec3d)
+    private boolean containsY(Vec3 vec3)
     {
-        if(vec3d == null)
+        if(vec3 == null)
         {
             return false;
         } else
         {
-            return vec3d.xCoord >= minX && vec3d.xCoord <= maxX && vec3d.zCoord >= minZ && vec3d.zCoord <= maxZ;
+            return vec3.x >= minX && vec3.x <= maxX && vec3.z >= minZ && vec3.z <= maxZ;
         }
     }
 
-    private boolean isVecInXY(Vec3d vec3d)
+    private boolean containsZ(Vec3 vec3)
     {
-        if(vec3d == null)
+        if(vec3 == null)
         {
             return false;
         } else
         {
-            return vec3d.xCoord >= minX && vec3d.xCoord <= maxX && vec3d.yCoord >= minY && vec3d.yCoord <= maxY;
+            return vec3.x >= minX && vec3.x <= maxX && vec3.y >= minY && vec3.y <= maxY;
         }
     }
 
-    public void setBB(AABB axisalignedbb)
+    public void setBB(AABB aabb)
     {
-        minX = axisalignedbb.minX;
-        minY = axisalignedbb.minY;
-        minZ = axisalignedbb.minZ;
-        maxX = axisalignedbb.maxX;
-        maxY = axisalignedbb.maxY;
-        maxZ = axisalignedbb.maxZ;
+        minX = aabb.minX;
+        minY = aabb.minY;
+        minZ = aabb.minZ;
+        maxX = aabb.maxX;
+        maxY = aabb.maxY;
+        maxZ = aabb.maxZ;
     }
 
     @Override
 	public String toString()
     {
-        return (new StringBuilder()).append("box[").append(minX).append(", ").append(minY).append(", ").append(minZ).append(" -> ").append(maxX).append(", ").append(maxY).append(", ").append(maxZ).append("]").toString();
+        return "box[" + minX + ", " + minY + ", " + minZ + " -> " + maxX + ", " + maxY + ", " + maxZ + "]";
     }
-
-    private static List boundingBoxes = new ArrayList();
-    private static int numBoundingBoxesInUse = 0;
-    public double minX;
-    public double minY;
-    public double minZ;
-    public double maxX;
-    public double maxY;
-    public double maxZ;
-
 }
diff --git a/src/main/java/net/minecraft/core/util/phys/HitResult.java b/src/main/java/net/minecraft/core/util/phys/HitResult.java
new file mode 100644
index 000000000..466bfc92e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/phys/HitResult.java
@@ -0,0 +1,53 @@
+package net.minecraft.core.util.phys;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+
+public class HitResult
+{
+    public final HitType hitType;
+    public final int x;
+    public final int y;
+    public final int z;
+    public final Side side;
+    public final Vec3 location;
+    public final Entity entity;
+
+    public HitResult(int x, int y, int z, Side side, Vec3 vec3)
+    {
+        hitType = HitType.TILE;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        this.side = side;
+        location = Vec3.getTempVec3(vec3.x, vec3.y, vec3.z);
+        entity = null;
+    }
+
+    public HitResult(Entity entity)
+    {
+        x = 0;
+        y = 0;
+        z = 0;
+        side = Side.NONE;
+        hitType = HitType.ENTITY;
+        this.entity = entity;
+        location = Vec3.getTempVec3(entity.x, entity.y, entity.z);
+    }
+
+    public double distanceToSquared(final Entity entity) {
+        final double diffX = this.location.x - entity.x;
+        final double diffY = this.location.y - entity.y;
+        final double diffZ = this.location.z - entity.z;
+        return diffX * diffX + diffY * diffY + diffZ * diffZ;
+    }
+    public double distanceTo(final Entity entity) {
+        return Math.sqrt(distanceToSquared(entity));
+    }
+    public enum HitType
+    {
+        TILE,
+        ENTITY
+    }
+}
diff --git a/src/main/java/net/minecraft/core/util/phys/Vec3.java b/src/main/java/net/minecraft/core/util/phys/Vec3.java
new file mode 100644
index 000000000..4688861a7
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/phys/Vec3.java
@@ -0,0 +1,236 @@
+package net.minecraft.core.util.phys;
+
+import net.minecraft.core.util.helper.MathHelper;
+
+import java.util.ArrayList;
+import java.util.List;
+
+// Referenced classes of package net.minecraft.src:
+//            MathHelper
+
+public class Vec3
+{
+    private static final List<Vec3> pool = new ArrayList<>();
+    private static int poolPointer = 0;
+    public double x;
+    public double y;
+    public double z;
+
+    public static Vec3 getPermanentVec3(double x, double y, double z)
+    {
+        return new Vec3(x, y, z);
+    }
+
+    public static void deinitializePool()
+    {
+        pool.clear();
+        poolPointer = 0;
+    }
+
+    public static void initializePool()
+    {
+        poolPointer = 0;
+    }
+
+    public static Vec3 getTempVec3(double x, double y, double z)
+    {
+        if(poolPointer >= pool.size())
+        {
+            pool.add(getPermanentVec3(0.0D, 0.0D, 0.0D));
+        }
+        return pool.get(poolPointer++).set(x, y, z);
+    }
+
+    public Vec3 makePermanent(){
+        if (pool.contains(this)){
+            pool.remove(this);
+            poolPointer--;
+        }
+        return this;
+    }
+
+    private Vec3(double x, double y, double z) {
+        if(x == -0D) {
+            x = 0.0D;
+        }
+        if(y == -0D) {
+            y = 0.0D;
+        }
+        if(z == -0D) {
+            z = 0.0D;
+        }
+        this.x = x;
+        this.y = y;
+        this.z = z;
+    }
+
+    private Vec3 set(double x, double y, double z)
+    {
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        return this;
+    }
+
+    public Vec3 vectorTo(Vec3 vec3)
+    {
+        return getTempVec3(vec3.x - x, vec3.y - y, vec3.z - z);
+    }
+
+    public Vec3 normalize()
+    {
+        double d = MathHelper.sqrt(x * x + y * y + z * z);
+        if(d < 0.0001D)
+        {
+            return getTempVec3(0.0D, 0.0D, 0.0D);
+        } else
+        {
+            return scale(1/d);
+        }
+    }
+    public double dotProduct(final Vec3 vec3) {
+        return this.x * vec3.x + this.y * vec3.y + this.z * vec3.z;
+    }
+    public Vec3 crossProduct(Vec3 vec3)
+    {
+        return getTempVec3(y * vec3.z - z * vec3.y, z * vec3.x - x * vec3.z, x * vec3.y - y * vec3.x);
+    }
+
+    public Vec3 add(double x, double y, double z)
+    {
+        return getTempVec3(this.x + x, this.y + y, this.z + z);
+    }
+
+    public Vec3 scale(double scalar){
+        return getTempVec3(this.x * scalar, this.y * scalar, this.z * scalar);
+    }
+
+    public double distanceTo(Vec3 vec3)
+    {
+        double diffX = vec3.x - x;
+        double diffY = vec3.y - y;
+        double diffZ = vec3.z - z;
+        return MathHelper.sqrt(diffX * diffX + diffY * diffY + diffZ * diffZ);
+    }
+
+    public double distanceToSquared(Vec3 vec3)
+    {
+        double diffX = vec3.x - x;
+        double diffY = vec3.y - y;
+        double diffZ = vec3.z - z;
+        return diffX * diffX + diffY * diffY + diffZ * diffZ;
+    }
+
+    public double distanceToSquared(double x, double y, double z)
+    {
+        double diffX = x - this.x;
+        double diffY = y - this.y;
+        double diffZ = z - this.z;
+        return diffX * diffX + diffY * diffY + diffZ * diffZ;
+    }
+
+    public double length()
+    {
+        return MathHelper.sqrt(x * x + y * y + z * z);
+    }
+
+    public Vec3 clipX(Vec3 vec3, double d)
+    {
+        double diffX = vec3.x - x;
+        double diffY = vec3.y - y;
+        double diffZ = vec3.z - z;
+        if(diffX * diffX < 1.0000000116860974E-007D)
+        {
+            return null;
+        }
+        double d4 = (d - x) / diffX;
+        if(d4 < 0.0D || d4 > 1.0D)
+        {
+            return null;
+        } else
+        {
+            return getTempVec3(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+        }
+    }
+
+    public Vec3 clipY(Vec3 vec3, double d)
+    {
+        double diffX = vec3.x - x;
+        double diffY = vec3.y - y;
+        double diffZ = vec3.z - z;
+        if(diffY * diffY < 1.0000000116860974E-007D)
+        {
+            return null;
+        }
+        double d4 = (d - y) / diffY;
+        if(d4 < 0.0D || d4 > 1.0D)
+        {
+            return null;
+        } else
+        {
+            return getTempVec3(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+        }
+    }
+
+    public Vec3 clipZ(Vec3 vec3, double d)
+    {
+        double diffX = vec3.x - x;
+        double diffY = vec3.y - y;
+        double diffZ = vec3.z - z;
+        if(diffZ * diffZ < 1.0000000116860974E-007D)
+        {
+            return null;
+        }
+        double d4 = (d - z) / diffZ;
+        if(d4 < 0.0D || d4 > 1.0D)
+        {
+            return null;
+        } else
+        {
+            return getTempVec3(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+        }
+    }
+
+    @Override
+	public String toString()
+    {
+        return "(" + x + ", " + y + ", " + z + ")";
+    }
+
+    public Vec3 lerp(final Vec3 vec3, final double progress) {
+        return getTempVec3(this.x + (vec3.x - this.x) * progress, this.y + (vec3.y - this.y) * progress, this.z + (vec3.z - this.z) * progress);
+    }
+    public void rotateAroundX(float radians)
+    {
+        final float cos = MathHelper.cos(radians);
+        final float sin = MathHelper.sin(radians);
+        final double x = this.x;
+        final double y = this.y * cos + this.z * sin;
+        final double z = this.z * cos - this.y * sin;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+    }
+
+    public void rotateAroundY(float radians)
+    {
+        final float cos = MathHelper.cos(radians);
+        final float sin = MathHelper.sin(radians);
+        final double x = this.x * cos + this.z * sin;
+        final double y = this.y;
+        final double z = this.z * cos - this.x * sin;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+    }
+    public void rotateAroundZ(final float radians) {
+        final float cos = MathHelper.cos(radians);
+        final float sin = MathHelper.sin(radians);
+        final double x = this.x * cos + this.y * sin;
+        final double y = this.y * cos - this.x * sin;
+        final double z = this.z;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+    }
+}
